from os import system
import sys
from numpy import *
from matplotlib.pyplot import *
from scipy.interpolate import interp1d
sys.path.append("../../Python/")
from wbounceenvfil import *
from readbrc import *

print("Writing env file...")

case_title = "Many layers"
freq = 500.0
rmaxkm = 10.0
clow  = 1500.0
chigh = 1.00e6
nmedia  = 2
options = "CAW"
parw = array([0.0, 1503.985,   0.0, 1.0 , 0.0, 0.0])
parl = array([[ 98.0, 1600.0, 130.0, 1.49, 0.1, 1.7],
              [128.0, 1800.0, 500.0, 1.9 , 0.9, 2.5],
	      [128.0, 2500.0, 900.0, 2.4 , 0.01, 0.01]])

print("Writing BOUNCE environmental input file...")

wbounceenvfil("manylayers",case_title,freq,nmedia,options,parw,parl,clow,chigh,rmaxkm)

print("Running BOUNCE...")

system("bounce.exe manylayers")

print("Reading the BRC file...")

thetas,R = readbrc("manylayers.brc")

figure(1)
plot(thetas,abs(R))
xlabel(r'$\theta$',fontsize=20)
ylabel(r'$|R(\theta)|$',fontsize=16)
title('BOUNCE')
grid(True)
show()

print("done")
