# Reflection coefficient
from os import system
import sys
from numpy import *
from matplotlib.pyplot import *
from scipy.interpolate import interp1d
sys.path.append("../../Python/")
from wbounceenvfil import *
from readbrc import *

case_title = "SACLANT"
rmaxkm = 10.0
clow  = 1500.0
chigh = 1.00e6
nmedia  = 2
options = "CAW"
parw = array( [0.0  ,1507.557, 0.0, 1.0, 0.0 , 0.0])
parl = array([[128.9,1505.0,   0.0, 2.0, 0.11, 0.0],
              [132.2,1556.0,   0.0, 2.0, 0.11, 0.0],
              [132.2,1576.0,   0.0, 1.6, 0.18, 0.0]])

thetamin =  5.0
thetamax = 85.0
nthetas = 101
thetas = linspace(thetamin,thetamax,nthetas)

freq = 331
wbounceenvfil("saclant",case_title,freq,nmedia,options,parw,parl,clow,chigh,rmaxkm)
system("bounce.exe saclant")
thetas,R = readbrc("saclant.brc")

figure(1)
plot(thetas,abs(R))
xlabel(r'$\theta$',fontsize=20)
ylabel(r'$|R(\theta)|$',fontsize=16)
title('BOUNCE')
grid(True)

show()

print("done")
