#=======================================================================
# 
# Bellhop: Dickins Seamount
# Faro, Sex Set 10 23:09:40 WEST 2021
# Written by Orlando Camargo Rodriguez 
# 
#=======================================================================

from os import system
from numpy import *
from scipy.io import *
from matplotlib.pyplot import *
sys.path.append ("../../../../Python/")
from plotray import *

print("Bellhop - Dickins Seamount:") 
print("Ray trace run") 
print("Geometric hat beams in Cartesian coordinates") 

fid = open('Dickins.bty','r')
theline = fid.readline()
theline = fid.readline()
n       = int( theline )
rbtykm  = zeros( n ) 
zbty    = zeros( n )
for i in range(n):
    theline = str( fid.readline() )
    datai = theline.split()
    rbtykm[ i] = float( datai[0] )
    zbty[   i] = float( datai[1] )
fid.close()

rbty = rbtykm*1000

system("bellhop.exe Dickins")

figure(1)
plotray('Dickins.ray')
plot(rbty,-zbty,'k',linewidth=2)
xlabel('Range (m)')
ylabel('Depth (m)')
title("Bellhop - Dickins Seamount")

show()

print("done.")
