#==================================================================
#  
#  Bellhop: Lower halfspace
#  Faro, Sex Set 10 18:30:36 WEST 2021
#  Written by Orlando Camargo Rodriguez
#  
#==================================================================

from os import *
import sys
from numpy import *
from scipy.io import *
from matplotlib.pyplot import *
sys.path.append ("../../../../Python/")
from readshd import *

rs = 0.0

print("Bellhop - Lower halfspace:") 
print("Coherent TL calculation")
print("Geometric hat beams in Cartesian coordinates")

system("bellhop.exe lower_half")

filename = 'lower_half.shd'
xs = nan
ys = nan
pressure,geometry = readshd(filename,xs,ys)

zs     = geometry["zs"]
rarray = geometry["rarray"]; rarraykm = rarray/1000
zarray = geometry["zarray"]

Dmax = zarray[-1]
rmax = rarray[-1]; rmaxkm = rmax/1000

p = squeeze( pressure )
p = where( p == 0.0, nan, p )
tl = -20*log10( abs( p ) )

figure(1)
plot(rarraykm,tl)
xlabel('Range (km)')
ylabel('TL (dB)')
title('Bellhop - Lower halfspace')
ylim(120,60)
grid(True)

show()

print("done.")
