#==================================================================
#  
#  Bellhop3D: 3D Munk profile, Nx2D, Hat Cart.
#  Faro, Sab Set 11 00:24:04 WEST 2021
#  Written by Orlando Camargo Rodriguez
#  
#==================================================================

from os import system
import sys
from numpy import *
from scipy.io import *
from pylab import *
sys.path.append("../../../../Python/")
from readshd import *

rs = 0.0

print("Bellhop3D - 3D Munk profile, Nx2D, Hat Cart.:")
print("Coherent TL calculation")
print("Geometric hat beams in Cartesian coordinates")

system("bellhop3d.exe slice2dHatCartInc")

filename = 'slice2dHatCartInc.shd'
xs = nan
ys = nan
pressure,geometry = readshd(filename,xs,ys)

zs     = geometry["zs"]
rarray = geometry["rarray"]; rarraykm = rarray/1000
zarray = geometry["zarray"]

Dmax = zarray[-1]
rmax = rarray[-1]; rmaxkm = rmax/1000

p = squeeze( pressure )
p = where( p == 0, nan, p )
tl = -20*log10( abs( p ) )
tl1 = squeeze( tl[0,:,:] )
tl2 = squeeze( tl[1,:,:] )

figure(1)
imshow(tl1,extent=[0,rmaxkm,0,Dmax],aspect='auto',cmap='jet_r',origin='lower',vmin=20,vmax=90)
cb = colorbar()
cb.ax.invert_yaxis()
plot(rs,zs,marker="<",markersize=16,color="k")
xlabel('Range (km)')
ylabel('Depth (m)')
title('Bellhop3D - 3D Munk profile, Nx2D, Hat Cart., bearing 0 degrees')
ylim(Dmax,0)

figure(2)
imshow(tl2,extent=[0,rmaxkm,0,Dmax],aspect='auto',cmap='jet_r',origin='lower',vmin=20,vmax=90)
cb = colorbar()
cb.ax.invert_yaxis()
plot(rs,zs,marker="<",markersize=16,color="k")
xlabel('Range (km)')
ylabel('Depth (m)')
title('Bellhop3D - 3D Munk profile, Nx2D, Hat Cart., bearing 1 degree')
ylim(Dmax,0)

show()

print("done.")
