#==================================================================
#  
#  Bellhop3D: Parabolic bottom profile, 3D Gaussian
#  Faro, Sab Set 11 00:18:45 WEST 2021
#  Written by Orlando Camargo Rodriguez
#  
#==================================================================

from os import system
import sys
from numpy import *
from scipy.io import *
from pylab import *
sys.path.append("../../../../Python/")
from readshd import *

rs = 0.0

print("Bellhop3D - Parabolic bottom profile, 3D Gaussian:")
print("Coherent TL calculation")
print("Geometric gaussian beams")

system("cp ParaBot.ati ParaBot3DGaussian.ati")
system("cp ParaBot.bty ParaBot3DGaussian.bty")
system("bellhop3d.exe ParaBot3DGaussian")
system("rm ParaBot3DGaussian.ati")
system("rm ParaBot3DGaussian.bty")

filename = 'ParaBot3DGaussian.shd'
xs = nan
ys = nan
pressure,geometry = readshd(filename,xs,ys)

zs     = geometry["zs"]
rarray = geometry["rarray"]; rarraykm = rarray/1000
zarray = geometry["zarray"]

Dmax = zarray[-1]
rmax = rarray[-1]; rmaxkm = rmax/1000

p = squeeze( pressure )
p = where( p == 0, nan, p )
tl = -20*log10( abs( p ) )

figure(1)
imshow(tl,extent=[0,rmaxkm,-Dmax,Dmax],aspect='auto',cmap='jet_r',origin='lower',vmin=20,vmax=90)
cb = colorbar()
cb.ax.invert_yaxis()
plot(rs,zs,marker="<",markersize=16,color="k")
xlabel('Range (km)')
ylabel('Depth (m)')
title('Bellhop3D - Parabolic bottom profile, 3D Gaussian')
ylim(Dmax,-Dmax)

show()

print("done.")
