#==================================================================
#  
#  Bellhop3D: Penetrable Wedge, 3D, 1801x900 hat beams, Ray coord. 15 degree critical
#  Faro, Sab Set 11 00:15:23 WEST 2021
#  Written by Orlando Camargo Rodriguez
#  
#==================================================================

from os import system
import sys
from numpy import *
from scipy.io import *
from matplotlib.pyplot import *
sys.path.append("../../../../Python/")
from readshd import *

rs = 0.0

print("Bellhop3D - Penetrable Wedge, 3D, 1801x900 hat beams, Ray coord. 15 degree critical:")
print("Coherent TL calculation")
print("Geometric hat beams in ray-centered coordinates")

system("bellhop3d.exe pwedge3dRayCen")

filename = 'pwedge3dRayCen.shd'
xs = nan
ys = nan
pressure,geometry = readshd(filename,xs,ys)

zs     = geometry["zs"]
rarray = geometry["rarray"]; rarraykm = rarray/1000
zarray = geometry["zarray"]

Dmax = zarray[-1]
rmax = rarray[-1]; rmaxkm = rmax/1000

bearings = linspace(-90,90,1801)

[R,Bearings] = meshgrid(rarray,bearings)

X = R*cos( Bearings*pi/180 ); Xkm = X/1000
Y = R*sin( Bearings*pi/180 ); Ykm = Y/1000

p = squeeze( pressure )
p = where( p == 0, nan, p )
tl = -20*log10( abs( p ) )

figure(1)
pcolor(Xkm,Ykm,tl,cmap='jet_r',vmin=40,vmax=140)
cb = colorbar()
cb.ax.invert_yaxis()
xlabel('X (km)')
ylabel('Y (km)')
title('Bellhop3D - Penetrable Wedge, 3D, 1801x900 hat beams, Ray coord. 15 degree critical')

show()

print("done.")
