#==================================================================
#  
#  Bellhop3D: Weymouth (3D run)
#  Faro, Sab Set 11 00:35:32 WEST 2021
#  Written by Orlando Camargo Rodriguez
#  
#==================================================================

from os import system
import sys
from numpy import *
from scipy.io import *
from matplotlib.pyplot import *
sys.path.append("../../../../Python/")
from readshd import *

rs = 0.0

print("Bellhop3D - Weymouth (3D run):")
print("Coherent TL calculation")
print("Geometric hat beams in Cartesian coordinates")

system("bellhop3d.exe Weymouth3D")

filename = 'Weymouth3D.shd'
xs = nan
ys = nan
pressure,geometry = readshd(filename,xs,ys)

zs     = geometry["zs"]
rarray = geometry["rarray"]; rarraykm = rarray/1000
zarray = geometry["zarray"]

Dmax = zarray[-1]
rmax = rarray[-1]; rmaxkm = rmax/1000

p = squeeze( pressure )
p = where( p == 0, nan, p )
tl = -20*log10( abs( p ) )
tl1 = squeeze( tl[0,:,:] )

figure(1)
imshow(tl1,extent=[0,rmaxkm,0,Dmax],aspect='auto',cmap='jet_r',origin='lower')
cb = colorbar()
cb.ax.invert_yaxis()
plot(rs,zs,marker="<",markersize=16,color="k")
xlabel('Range (km)')
ylabel('Depth (m)')
title('Bellhop3D - Weymouth (3D run)')
ylim(Dmax,0)

show()

print("done.")
