#==================================================================
#  
#  KRAKEN: Pekeris manual case
#  Faro, Sab Set 11 01:29:29 WEST 2021
#  Written by Orlando Camargo Rodriguez
#  
#==================================================================

from os import *
import sys
from numpy import *
from scipy.io import *
from matplotlib.pyplot  import *
sys.path.append ("../../../../Python/")
from readshd import *

rs = 0.0

print("KRAKEN - Pekeris manual case")

system("kraken.exe pekeris")
system("field.exe pekeris < pekeris.flp")

filename = 'pekeris.shd'
xs = nan
ys = nan
pressure,geometry = readshd(filename,xs,ys)

zs     = geometry["zs"]
rarray = geometry["rarray"]; rarraykm = rarray/1000
zarray = geometry["zarray"]

Dmax = zarray[-1]
rmax = rarray[-1]; rmaxkm = rmax/1000

p = squeeze( pressure )
p = where( p == 0, nan, p )
tl = -20*log10( abs( p ) )
tlmin = min( tl )
tlmax = max( tl )

figure(1)
plot(rarraykm,tl)
xlabel('Range (km)')
ylabel('TL (dB)')
title('KRAKEN - Pekeris manual case')
ylim(tlmax,tlmin)
grid(True)

show()

print("done.")
